<?php

namespace App\DataTables;

use App\Models\Tavolo;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Validation\Rule;
use Yajra\DataTables\DataTablesEditor;
use Illuminate\Http\Request;
use Illuminate\Validation\ValidationException;
use Storage;
use Illuminate\Support\Str;

class TavoloDataTableEditor extends DataTablesEditor
{
  protected $model = Tavolo::class;
  // protected $uploadDir = '';
  // protected $disk = 'modelliRicevute';

  protected $messages = [
    'label.required' => 'Il label è richiesto',
    'posti.required' => 'Il numero di posti è richiesto',
    'ubicazione.required' => 'L\'ubicazione è richiesta',
    'is_attivo.required' => 'Indicare una delle due opzioni',
  ];

  /**
  * Get create action validation rules.
  *
  * @return array
  */
  public function createRules(): array
  {
    return [
      'label'  => 'required',
      'attivita_id' => 'required|exists:attivita,id',
      'posti' => 'nullable|numeric|min:0',
      'ubicazione' => 'nullable',
      'is_attivo' => 'boolean',
    ];
  }

  public function createMessages(): array{
    return $this->messages;
  }

  /**
  * Get edit action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function editRules(Model $model): array
  {
    return [
      'label'  => 'required',
      'attivita_id' => 'required|exists:attivita,id',
      'posti' => 'nullable|numeric|min:0',
      'ubicazione' => 'nullable',
      'is_attivo' => 'boolean',
    ];
  }

  public function editMessages(): array{
    return $this->messages;
  }

  /**
  * Get remove action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function removeRules(Model $model): array
  {
    return [];
  }

  public function creating(Model $model, array $data): array
  {
    // $model->roles()->sync([$data['ruolo_id']]);
    $data['is_attivo'] = isset($data['is_attivo']) ? true : false;
    return $data;
  }

  public function updating(Model $model, array $data): array
  {
    // dd($data['ruolo']);
    // $model->roles()->sync([$data['ruolo_id']]);
    $data['is_attivo'] = isset($data['is_attivo']) ? true : false;
    return $data;
  }
  public function messages(): array
  {
    return $this->messages;
  }

}
